Index: kernel/arch/ia32/src/pm.c
===================================================================
--- kernel/arch/ia32/src/pm.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/pm.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -44,5 +44,5 @@
 #include <mm/frame.h>
 #include <stdlib.h>
-#include <mem.h>
+#include <memw.h>
 #include <arch/boot/boot.h>
 #include <interrupt.h>
Index: kernel/arch/ia32/src/smp/ap.S
===================================================================
--- kernel/arch/ia32/src/smp/ap.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/smp/ap.S	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -75,6 +75,6 @@
 	movw %ax, %es
 	movw %ax, %ss
-	movl $KA2PA(ctx), %eax          /* KA2PA((uintptr_t) &ctx) */
-	movl CONTEXT_OFFSET_SP(%eax), %esp
+	movl $KA2PA(bootstrap_stack_top), %eax   /* KA2PA((uintptr_t) &bootstrap_stack_top) */
+	movl (%eax), %esp
 	leal KA2PA(0)(%esp), %esp       /* KA2PA(ctx.sp) */
 
Index: kernel/arch/ia32/src/smp/smp.c
===================================================================
--- kernel/arch/ia32/src/smp/smp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/smp/smp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -54,5 +54,5 @@
 #include <mm/as.h>
 #include <log.h>
-#include <mem.h>
+#include <memw.h>
 #include <genarch/drivers/i8259/i8259.h>
 #include <cpu.h>
@@ -178,6 +178,5 @@
 			 * supposed to wake us up.
 			 */
-			if (waitq_sleep_timeout(&ap_completion_wq, 1000000,
-			    SYNCH_FLAGS_NONE, NULL) == ETIMEOUT) {
+			if (semaphore_down_timeout(&ap_completion_semaphore, 1000000) != EOK) {
 				log(LF_ARCH, LVL_NOTE, "%s: waiting for cpu%u "
 				    "(APIC ID = %d) timed out", __FUNCTION__,
Index: kernel/arch/ia64/_link.ld.in
===================================================================
--- kernel/arch/ia64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -15,30 +15,71 @@
 	kernel_load_address = LOAD_ADDRESS_V;
 
-	.image (LOAD_ADDRESS_V + SIZEOF_HEADERS): AT (LOAD_ADDRESS_P + SIZEOF_HEADERS) {
+	.text (LOAD_ADDRESS_V + SIZEOF_HEADERS): AT (LOAD_ADDRESS_P + SIZEOF_HEADERS) {
 		. = ALIGN(16);
 		ktext_start = .;
-		*(K_TEXT_START);
+		KEEP(*(K_TEXT_START));
 		*(.text .text.*)
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+	
+	.data : {
 		kdata_start = .;
-		*(K_DATA_START)
-		*(.rodata .rodata.*)
+		KEEP(*(K_DATA_START));
+		*(.rodata .rodata.*);
 		*(.opd)
 		*(.data .data.*)
 		__gp = .;
 		*(.got .got.*)
-		*(.sdata)
-		*(.sbss)
-		*(.scommon)
-		*(.bss)
+		*(.sdata .sdata.*)
+		*(.sbss .sbss.*)
+		*(.scommon .scommon.*)
+		*(.bss .bss.*)
 		*(COMMON);
-
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);            /* Symbol table, must be LAST symbol!*/
-
 		kdata_end = .;
 	}
+
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/ia64/include/arch/asm.h
===================================================================
--- kernel/arch/ia64/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -44,4 +44,8 @@
 #define IO_SPACE_BOUNDARY       ((void *) (64 * 1024))
 
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+}
+
 /** Map the I/O port address to a legacy I/O address. */
 _NO_TRACE static inline uintptr_t p2a(volatile void *p)
@@ -469,4 +473,16 @@
     uint64_t, uint64_t);
 
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	// FIXME: do this properly
+	interrupts_enable();
+	cpu_sleep();
+	interrupts_disable();
+}
+
 #endif
 
Index: kernel/arch/ia64/include/arch/context_struct.h
===================================================================
--- kernel/arch/ia64/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -72,6 +72,5 @@
 #define CONTEXT_OFFSET_F30             0x1d0
 #define CONTEXT_OFFSET_F31             0x1e0
-#define CONTEXT_OFFSET_IPL             0x1f0
-#define CONTEXT_SIZE                   0x200
+#define CONTEXT_SIZE                   0x1f0
 
 #ifndef __ASSEMBLER__
@@ -136,6 +135,4 @@
 	uint128_t f30;
 	uint128_t f31;
-
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/ia64/include/arch/fpu_context.h
===================================================================
--- kernel/arch/ia64/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,6 +36,4 @@
 #define KERN_ia64_FPU_CONTEXT_H_
 
-#define FPU_CONTEXT_ALIGN 16
-
 #include <_bits/int128_t.h>
 
@@ -43,5 +41,5 @@
 
 typedef struct {
-	uint128_t fr[FRS];
+	_Alignas(16) uint128_t fr[FRS];
 } fpu_context_t;
 
Index: kernel/arch/ia64/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia64/src/cpu/cpu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/src/cpu/cpu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,5 +37,5 @@
 #include <arch/register.h>
 #include <stdio.h>
-#include <mem.h>
+#include <memw.h>
 
 void cpu_arch_init(void)
Index: kernel/arch/ia64/src/drivers/it.c
===================================================================
--- kernel/arch/ia64/src/drivers/it.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/src/drivers/it.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -122,5 +122,5 @@
 		itm += IT_DELTA;
 		if (itm - itc < 0)
-			CPU->missed_clock_ticks++;
+			CPU_LOCAL->missed_clock_ticks++;
 		else
 			break;
Index: kernel/arch/ia64/src/drivers/ski.c
===================================================================
--- kernel/arch/ia64/src/drivers/ski.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/src/drivers/ski.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -258,5 +258,5 @@
 
 	instance->srlnin = srlnin;
-	thread_ready(instance->thread);
+	thread_start(instance->thread);
 
 	sysinfo_set_item_val("kbd", NULL, true);
Index: kernel/arch/ia64/src/mm/vhpt.c
===================================================================
--- kernel/arch/ia64/src/mm/vhpt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia64/src/mm/vhpt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,5 +33,5 @@
  */
 
-#include <mem.h>
+#include <memw.h>
 #include <arch/barrier.h>
 #include <arch/mm/vhpt.h>
Index: kernel/arch/mips32/_link.ld.in
===================================================================
--- kernel/arch/mips32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,21 +28,35 @@
 	.text : {
 		ktext_start = .;
+		/* FIXME: for some reason, mixing .text with .text.* produces a crash on malta-be */
 		*(.text);
+		*(.text.*);
 		ktext_end = .;
 	}
+
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
 	.data : {
 		kdata_start = .;
-		*(.data);                       /* initialized data */
-		*(.rodata*);
-		*(.sdata);
+		*(.data .data.*);                       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
 		*(.reginfo);
-		*(.sbss);
-		*(.scommon);
-		*(.bss);                        /* uninitialized static variables */
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		*(.bss .bss.*);                        /* uninitialized static variables */
 		*(COMMON);                      /* global variables */
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);
 	}
+
 	_gp = . + 0x8000;
 	.lit8 : { *(.lit8) }
@@ -50,4 +64,35 @@
 
 	kdata_end = .;
+
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/mips32/include/arch/asm.h
===================================================================
--- kernel/arch/mips32/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -45,4 +45,8 @@
 }
 
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+}
+
 _NO_TRACE static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
@@ -85,4 +89,16 @@
 extern bool interrupts_disabled(void);
 
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	// FIXME: do this atomically
+	interrupts_enable();
+	cpu_sleep();
+	interrupts_disable();
+}
+
 #endif
 
Index: kernel/arch/mips32/include/arch/context_struct.h
===================================================================
--- kernel/arch/mips32/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,6 +43,5 @@
 #define CONTEXT_OFFSET_GP  0x2c
 #define CONTEXT_OFFSET_TP  0x30
-#define CONTEXT_OFFSET_IPL 0x34
-#define CONTEXT_SIZE       0x38
+#define CONTEXT_SIZE       0x34
 
 #ifndef __ASSEMBLER__
@@ -66,5 +65,4 @@
 	/* We use the K1 register for userspace thread pointer. */
 	uint32_t tp;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/mips32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/mips32/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,6 +39,4 @@
 #include <arch/fpu_context_struct.h>
 
-#define FPU_CONTEXT_ALIGN    sizeof(sysarg_t)
-
 #endif
 
Index: kernel/arch/mips32/include/arch/fpu_context_struct.h
===================================================================
--- kernel/arch/mips32/include/arch/fpu_context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/include/arch/fpu_context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,5 +42,5 @@
 
 typedef struct fpu_context {
-	sysarg_t dregs[32];
+	_Alignas(sizeof(sysarg_t)) sysarg_t dregs[32];
 	sysarg_t cregs[32];
 } fpu_context_t;
Index: kernel/arch/mips32/src/interrupt.c
===================================================================
--- kernel/arch/mips32/src/interrupt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/src/interrupt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -121,5 +121,5 @@
 	while (drift > cp0_compare_value) {
 		drift -= cp0_compare_value;
-		CPU->missed_clock_ticks++;
+		CPU_LOCAL->missed_clock_ticks++;
 	}
 
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/src/mips32.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -40,5 +40,6 @@
 #include <macros.h>
 #include <str.h>
-#include <mem.h>
+#include <memw.h>
+#include <preemption.h>
 #include <userspace.h>
 #include <stdbool.h>
Index: kernel/arch/mips32/src/mm/frame.c
===================================================================
--- kernel/arch/mips32/src/mm/frame.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/mips32/src/mm/frame.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -113,7 +113,7 @@
 		return false;
 
-	/* Kernel stack */
+	/* Boot allocations */
 	if (overlaps(frame << ZERO_PAGE_WIDTH, ZERO_PAGE_SIZE,
-	    KA2PA(config.stack_base), config.stack_size))
+	    KA2PA(ballocs.base), ballocs.size))
 		return false;
 
Index: kernel/arch/ppc32/_link.ld.in
===================================================================
--- kernel/arch/ppc32/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ppc32/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -22,29 +22,70 @@
 	.unmapped (SIZEOF_HEADERS): AT (SIZEOF_HEADERS) {
 		. = ALIGN(0x100);
-		*(K_UNMAPPED_TEXT_START);
+		KEEP(*(K_UNMAPPED_TEXT_START));
 	}
 
-	.mapped PA2KA(BOOT_OFFSET): AT (BOOT_OFFSET) {
+	.text PA2KA(BOOT_OFFSET): AT (BOOT_OFFSET) {
 		ktext_start = .;
-		*(K_TEXT_START);
-		*(.text);
+		KEEP(*(K_TEXT_START));
+		*(.text .text.*);
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
+	.data : {
 		kdata_start = .;
-		*(K_DATA_START);
+		KEEP(*(K_DATA_START));
 		*(.rodata .rodata.*);
-		*(.data);       /* initialized data */
-		*(.sdata);
-		*(.sdata2);
-		*(.sbss);
-		*(.bss);        /* uninitialized static variables */
+		*(.data .data.*);       /* initialized data */
+		*(.sdata .sdata.*);
+		*(.sdata2 .sdata2.*);
+		*(.sbss .sbss.*);
+		*(.bss .bss.*);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);    /* Symbol table, must be LAST symbol!*/
-
 		kdata_end = .;
 	}
+
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/ppc32/include/arch/asm.h
===================================================================
--- kernel/arch/ppc32/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ppc32/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,4 +42,8 @@
 #include <trace.h>
 
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+}
+
 _NO_TRACE static inline uint32_t msr_read(void)
 {
@@ -163,6 +167,13 @@
 }
 
-_NO_TRACE static inline void cpu_sleep(void)
-{
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	// FIXME: do this properly
+	interrupts_enable();
+	interrupts_disable();
 }
 
Index: kernel/arch/ppc32/include/arch/context_struct.h
===================================================================
--- kernel/arch/ppc32/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ppc32/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -53,6 +53,5 @@
 #define CONTEXT_OFFSET_R31  0x54
 #define CONTEXT_OFFSET_CR   0x58
-#define CONTEXT_OFFSET_IPL  0x5c
-#define CONTEXT_SIZE        0x60
+#define CONTEXT_SIZE        0x5c
 
 #ifndef __ASSEMBLER__
@@ -84,5 +83,4 @@
 	uint32_t r31;
 	uint32_t cr;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/ppc32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/ppc32/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ppc32/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,6 +36,4 @@
 #define KERN_ppc32_FPU_CONTEXT_H_
 
-#define FPU_CONTEXT_ALIGN	8
-
 #include <arch/fpu_context_struct.h>
 
Index: kernel/arch/ppc32/include/arch/fpu_context_struct.h
===================================================================
--- kernel/arch/ppc32/include/arch/fpu_context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ppc32/include/arch/fpu_context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -70,5 +70,5 @@
 
 typedef struct fpu_context {
-	uint64_t fr0;
+	_Alignas(8) uint64_t fr0;
 	uint64_t fr1;
 	uint64_t fr2;
Index: kernel/arch/ppc32/src/mm/frame.c
===================================================================
--- kernel/arch/ppc32/src/mm/frame.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ppc32/src/mm/frame.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,4 +33,5 @@
  */
 
+#include <arch/asm.h>
 #include <arch/boot/boot.h>
 #include <arch/mm/frame.h>
Index: kernel/arch/riscv64/_link.ld.in
===================================================================
--- kernel/arch/riscv64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/riscv64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -16,24 +16,66 @@
 	kernel_load_address = PA2KA(BOOT_OFFSET);
 
-	.image (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS) : AT (BOOT_OFFSET + SIZEOF_HEADERS) {
+	.text (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS) : AT (BOOT_OFFSET + SIZEOF_HEADERS) {
 		ktext_start = .;
-		*(K_TEXT_START);
-		*(.text);
+		KEEP(*(K_TEXT_START));
+		*(.text .text.*);
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
+	.data : {
 		kdata_start = .;
-		*(.data);                       /* initialized data */
-		*(.rodata*);
-		*(.sdata);
-		*(.reginfo);
-		*(.sbss);
-		*(.scommon);
-		*(.bss);                        /* uninitialized static variables */
+		*(.data .data.*);                       /* initialized data */
+		*(.rodata .rodata.*);
+		*(.sdata .sdata.*);
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
+		*(.bss .bss.*);                        /* uninitialized static variables */
 		*(COMMON);                      /* global variables */
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);
 		kdata_end = .;
 	}
+
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/riscv64/include/arch/asm.h
===================================================================
--- kernel/arch/riscv64/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/riscv64/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,4 +41,8 @@
 #include <arch/mm/asid.h>
 #include <trace.h>
+
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+}
 
 _NO_TRACE static inline ipl_t interrupts_enable(void)
@@ -91,6 +95,13 @@
 }
 
-_NO_TRACE static inline void cpu_sleep(void)
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
 {
+	// FIXME: do this properly
+	interrupts_enable();
+	interrupts_disable();
 }
 
Index: kernel/arch/riscv64/include/arch/context_struct.h
===================================================================
--- kernel/arch/riscv64/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/riscv64/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,6 +46,5 @@
 #define CONTEXT_OFFSET_S10  0x70
 #define CONTEXT_OFFSET_S11  0x78
-#define CONTEXT_OFFSET_IPL  0x80
-#define CONTEXT_SIZE        0x88
+#define CONTEXT_SIZE        0x80
 
 #ifndef __ASSEMBLER__
@@ -70,5 +69,4 @@
 	uint64_t s10;
 	uint64_t s11;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/riscv64/src/riscv64.c
===================================================================
--- kernel/arch/riscv64/src/riscv64.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/riscv64/src/riscv64.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -50,5 +50,5 @@
 #include <proc/thread.h>
 #include <console/console.h>
-#include <mem.h>
+#include <memw.h>
 #include <str.h>
 
Index: kernel/arch/sparc64/_link.ld.in
===================================================================
--- kernel/arch/sparc64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -14,27 +14,68 @@
 	kernel_load_address = VMA;
 
-	.image (VMA + SIZEOF_HEADERS): AT (LMA + SIZEOF_HEADERS) {
+	.text (VMA + SIZEOF_HEADERS): AT (LMA + SIZEOF_HEADERS) {
 		ktext_start = .;
-		*(K_TEXT_START)
+		KEEP(*(K_TEXT_START));
 		*(.text .text.*);
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
+	.data : {
 		kdata_start = .;
-		*(K_DATA_START)
+		KEEP(*(K_DATA_START));
 		*(.rodata .rodata.*);
-		*(.data);                   /* initialized data */
-		*(.sdata);
-		*(.sdata2);
-		*(.sbss);
+		*(.data .data.*);                   /* initialized data */
+		*(.sdata .sdata.*);
+		*(.sdata2 .sdata2.*);
+		*(.sbss .sbss.*);
 		. = ALIGN(8);
-		*(.bss);                    /* uninitialized static variables */
+		*(.bss .bss.*);                    /* uninitialized static variables */
 		*(COMMON);                  /* global variables */
-
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);                /* Symbol table, must be LAST symbol!*/
-
 		kdata_end = .;
 	}
+
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/sparc64/include/arch/asm.h
===================================================================
--- kernel/arch/sparc64/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -44,4 +44,8 @@
 #include <trace.h>
 
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+}
+
 _NO_TRACE static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
@@ -535,4 +539,16 @@
 extern void switch_to_userspace(uint64_t pc, uint64_t sp, uint64_t uarg);
 
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	// FIXME: do this atomically
+	interrupts_enable();
+	cpu_sleep();
+	interrupts_disable();
+}
+
 #endif
 
Index: kernel/arch/sparc64/include/arch/context_struct.h
===================================================================
--- kernel/arch/sparc64/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -49,6 +49,5 @@
 #define CONTEXT_OFFSET_L7   0x88
 #define CONTEXT_OFFSET_TP   0x90
-#define CONTEXT_OFFSET_IPL  0x98
-#define CONTEXT_SIZE        0xa0
+#define CONTEXT_SIZE        0x98
 
 #ifndef __ASSEMBLER__
@@ -76,5 +75,4 @@
 	uint64_t l7;
 	uint64_t tp;  // %g7
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/sparc64/include/arch/fpu_context.h
===================================================================
--- kernel/arch/sparc64/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,9 +38,7 @@
 #include <stdint.h>
 
-#define FPU_CONTEXT_ALIGN	8
-
 typedef struct {
-	uint64_t	d[32];
-	uint64_t	fsr;
+	_Alignas(8) uint64_t d[32];
+	uint64_t fsr;
 } fpu_context_t;
 
Index: kernel/arch/sparc64/src/drivers/niagara.c
===================================================================
--- kernel/arch/sparc64/src/drivers/niagara.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/drivers/niagara.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -253,5 +253,5 @@
 
 			instance->srlnin = srln;
-			thread_ready(instance->thread);
+			thread_start(instance->thread);
 		}
 	}
Index: kernel/arch/sparc64/src/drivers/tick.c
===================================================================
--- kernel/arch/sparc64/src/drivers/tick.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/drivers/tick.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -117,5 +117,5 @@
 	while (drift > CPU->arch.clock_frequency / HZ) {
 		drift -= CPU->arch.clock_frequency / HZ;
-		CPU->missed_clock_ticks++;
+		CPU_LOCAL->missed_clock_ticks++;
 	}
 	CPU->arch.next_tick_cmpr = tick_counter_read() +
Index: kernel/arch/sparc64/src/mm/sun4u/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/as.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/mm/sun4u/as.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -47,5 +47,5 @@
 #include <bitops.h>
 #include <macros.h>
-#include <mem.h>
+#include <memw.h>
 
 #endif /* CONFIG_TSB */
